Subject: Re: bug#3408: customize-face not working: seems to apply to frame-face

From: Chong Yidong <[email-masked]>
Date: Thu, 28 May 2009 13:08:18 -0400

"Drew Adams" <[email-masked]> writes:

>> Mixing set-face-attribute and Customize is a bad idea in general.
>
> It *should not* be a bad idea - or, put as a question, why *should* it
> be a bad idea? Logically, where is the problem?

It's a bad idea in general because face computation has to take into
account subtle interactions between face-new-frame-defaults, defface
settings, X resources (which can be per-frame!), Customize, etc etc etc.
Between Emacs 21 and 22, and between Emacs 22 and 23, there have been
lots of changes in these subtle interactions, many of which are not easy
to explain.

I will take a look at this specific bug, and see if there is an
acceptable fix.  But my advice for the user is to settle on one single
method for changing faces, and stick to it.

In the long run, we need to figure out a way to simplify how faces are
computed, so that this kind of problem does not arise so easily.